package ru.dbotthepony.kstarbound.defs.item.impl

import ru.dbotthepony.kommons.math.RGBAColor
import ru.dbotthepony.kommons.vector.Vector2d
import ru.dbotthepony.kstarbound.defs.item.api.IFlashlightDefinition
import ru.dbotthepony.kstarbound.defs.item.api.IItemDefinition
import ru.dbotthepony.kstarbound.json.builder.JsonFactory
import ru.dbotthepony.kstarbound.json.builder.JsonFlat

@JsonFactory(logMisses = false)
class FlashlightDefinition(
	@JsonFlat
	val parent: IItemDefinition,

	override val lightPosition: Vector2d,
	override val lightColor: RGBAColor,
	override val beamLevel: Int,
	override val beamAmbience: Double,
	override val handPosition: Vector2d,
	override val maxStack: Long = 1L,
) : IItemDefinition by parent, IFlashlightDefinition
