package ru.dbotthepony.kstarbound.defs.world

import com.google.common.collect.ImmutableList
import ru.dbotthepony.kstarbound.Registry
import ru.dbotthepony.kstarbound.defs.tile.MaterialModifier
import ru.dbotthepony.kstarbound.defs.tile.TileDefinition
import ru.dbotthepony.kstarbound.defs.world.AmbientNoisesDefinition
import ru.dbotthepony.kstarbound.defs.world.BiomePlaceables
import ru.dbotthepony.kstarbound.defs.world.Parallax

data class Biome(
	val hueShift: Double = 0.0,
	val baseName: String,
	val description: String,
	val mainBlock: Registry.Entry<TileDefinition>? = null,
	val subBlocks: ImmutableList<Registry.Entry<TileDefinition>> = ImmutableList.of(),
	val ores: ImmutableList<Pair<Registry.Entry<MaterialModifier>, Double>> = ImmutableList.of(),
	val musicTrack: AmbientNoisesDefinition? = null,
	val ambientNoises: AmbientNoisesDefinition? = null,
	val surfacePlaceables: BiomePlaceables = BiomePlaceables(),
	val undergroundPlaceables: BiomePlaceables = BiomePlaceables(),
	val parallax: Parallax? = null,
)
