package ru.dbotthepony.kstarbound.world.api

import java.io.DataInputStream

data class MutableCell(
	override var foreground: MutableTileState = MutableTileState(),
	override var background: MutableTileState = MutableTileState(),
	override var liquid: MutableLiquidState = MutableLiquidState(),

	override var dungeonId: Int = 0,
	override var biome: Int = 0,
	override var envBiome: Int = 0,
	override var isIndestructible: Boolean = false,
) : AbstractCell() {
	fun read(stream: DataInputStream): MutableCell {
		foreground.read(stream)
		background.read(stream)
		liquid.read(stream)

		stream.skipNBytes(1) // collisionMap

		dungeonId = stream.readUnsignedShort()
		biome = stream.readUnsignedByte()
		envBiome = stream.readUnsignedByte()
		isIndestructible = stream.readBoolean()

		stream.skipNBytes(1) // unknown
		return this
	}

	override fun immutable(): ImmutableCell {
		return POOL.intern(ImmutableCell(foreground.immutable(), background.immutable(), liquid.immutable(), dungeonId, biome, envBiome, isIndestructible))
	}

	override fun mutable(): MutableCell {
		return this
	}
}
